﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2017 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using HeuristicLab.Common;
using HeuristicLab.Core;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

namespace HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms.CPLEX {
  [Item("CPLEX Context", "A context for CPLEX solvers.")]
  public class CplexContext : SingleSolutionContext<ISingleObjectiveSolutionScope<GQAPSolution>> {
    
    [StorableConstructor]
    protected CplexContext(bool deserializing) : base(deserializing) { }
    protected CplexContext(CplexContext original, Cloner cloner)
      : base(original, cloner) {
    }
    public CplexContext() : base() { }
    public CplexContext(string name) : base(name) { }
    public CplexContext(string name, ParameterCollection parameters) : base(name, parameters) { }
    public CplexContext(string name, string description) : base(name, description) { }
    public CplexContext(string name, string description, ParameterCollection parameters) : base(name, description, parameters) { }
    
    public override IDeepCloneable Clone(Cloner cloner) {
      return new CplexContext(this, cloner);
    }
  }
}
